'''
Emily Kampa, Evie Rosenberg, Allie Warren, Phoebe Wooldridge 
GoScenic Senior Comps Project 
Computer Science Department
Carleton College
March 12, 2017
Advisor: Dave Musicant

File that creates grid for Washington State by increasing latitude values 
by 0.009 degree increments, and increasing longitudes by increments of (1/111.111*cos(lat)). 
These increments represent an increase of a km.
    1 degree latitude = 111.111 km
    1 degree longitude = 111.111 * cos(latitude) km
'''

import find_relevant_area
import math
from math import *  
import json
import io

# These are (roughly) the four corners of Washington state.
arr = [[46.213079, -124.872909],[46.225226, -117.129058],[48.954045, -117.098910],[49.026333, -124.886684]]

'''
Creates grid given four corners of Washington State.
'''
def create_grid_coords(coordsArray):
    try:
        f = open("js_coords.csv", "w")

        bottom_left = coordsArray[0]
        bottom_right = coordsArray[1]
        top_right = coordsArray[2]
        top_left = coordsArray[3]
        grid_array = []
        grid_array.append(bottom_left)
        grid_array.append(bottom_right)
        grid_array.append(top_right)
        grid_array.append(top_left)

        # LAT lower bound
        if bottom_left[0] <= top_left[0]:
            lowerX = bottom_left[0]
        else:
            lowerX = top_left[0]

        # LAT upper bound
        if bottom_right[0] <= top_right[0]:
            upperX = top_right[0]
        else:
            upperX = bottom_right[0]

        # LONG lower bound
        if bottom_left[1] <= bottom_right[1]:
            lowerY = bottom_left[1]
        else: 
            lowerY = bottom_right[1]

        # LONG upper bound
        if top_left[1] <= top_right[1]:
            upperY = top_right[1]
        else:
            upperY = top_left[1]


        y = lowerY
        while y <= upperY:
            x = lowerX
            while x <= upperX:
                grid_array.append([x,y])
                f.write("[" + str(x) + "," + str(y) + "]\n")
                x += 0.009 
            grid_array.append([x,y])
            y += (1/(111.111 * math.cos(math.radians(x)) )) 	# Increase longitude by 1 km
        f.close()
        return grid_array 
    except IOError as (errno,strerror):
        print "ERROR"


create_grid_coords(arr)




